<?php
/*
Mage Reviews
*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/* Basic plugin definitions */
/*
 * @level 		Casting
 * @author		Mage Cast 
 * @url			http://magecast.com
 * @license   	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
?>
<?php
if (!defined('MAGECORE')) exit;
add_action('init', 'summon_core');
function summon_core(){	
	if (current_user_can('switch_themes')) {
		do_action('mage_summon_craft');	
		add_action('admin_init', 'mage_init' );	
		add_action('admin_menu', 'summon_dashboard');				
	}
}
function mage_verify_image($id='', $src=''){
	$check = false;
	if (empty($id) || empty($src)) return $check;
	$comp = wp_get_attachment_image_src($id,'full');
	if (!$comp) return $check;
	if ($comp[0] == $src)return true;
	return $check;
}
function mage_post_type_options($unset=array(),$args=array(),$set=array('post','page')){
	$options=array();
	$types = mage_get_post_types($args,'names','and',$unset);
	$types = $types + $set;
	foreach ($types as $type) {
		$name = get_post_type_object($type)->labels->singular_name;
		$slug = get_post_type_object($type)->name;
		$options[$slug] = $name;		
	}
	return $options;
}
function mage_load_scripts() {		
	wp_enqueue_script('jquery');
	wp_enqueue_script('thickbox');       
    wp_enqueue_script('media-upload'); 	
	wp_enqueue_script('mage_admin_js',MAGESOURCE.'js/magecast.js');
	wp_enqueue_script('mage-components',MAGESOURCE.'js/bootstrap.min.js');
	wp_print_scripts( array( 'sack' ));
		?>
			<script>
				function mage_img_delete(id){					
					var mysack = new sack("<?php echo admin_url('admin-ajax.php'); ?>" );
				  	mysack.execute = 1;
				  	mysack.method = 'POST';
				  	mysack.setVar( "action", "mage_img_delete" );
				  	mysack.setVar( "id",id);
				  	mysack.encVar( "cookie", document.cookie, false );
				  	mysack.onError = function() { alert('Error Deleting Image.' )};
				  	mysack.runAJAX();
					return true;
				}		
				
			</script>
		<?php

}
function replace_mage_upload_text($translated_text, $text, $domain) { 
    if ('Insert into Post' == $text) { 
        $referer = wp_get_referer(); 
        if ( $referer != '' ) {return __('Use This Image', 'paladin'); } 
    }  
    return $translated_text;  
}
function summon_dashboard(){
	global $themename, $shortname, $submenu, $menu, $mage;
	$mage_options_page = add_menu_page('Mage Reviews','Mage Cast','manage_options','mage_cast', 'mage_page',MAGESOURCE.'images/icon.png','26.9');	
	add_submenu_page('mage_cast','Mage Reviews','Reviews','manage_options','mage_cast','mage_page');	
	add_action('admin_print_scripts-'.$mage_options_page, 'mage_load_scripts');			
	add_action('admin_print_styles-'.$mage_options_page, 'mage_load_styles' );	
	$submenu['mage_cast'][0][0] = 'Reviews';
	do_action('summon_dashboards');
}
function mage_load_styles() {
	wp_enqueue_style('thickbox'); 
	wp_enqueue_style('bootstrap_style_full',MAGESOURCE.'css/bootstrap.full.min.css');
	wp_enqueue_style('icons',MAGESOURCE.'css/glyphicons.min.css');		
	wp_enqueue_style('mage-fonts','http://fonts.googleapis.com/css?family=Lato:400,700|Philosopher:400,700');
	wp_enqueue_style('mage-options',MAGESOURCE.'css/magecast.css');
}
function mage_init() {			
	global $pagenow;	
	if('media-upload.php' == $pagenow || 'async-upload.php' == $pagenow )add_filter( 'gettext', 'replace_mage_upload_text',1,3);
	require_once MAGECORE.'mage-sanitize.php';
	$mage_settings = get_option('mage');
	$id = 'mage_ratings';
	if (isset($mage_settings['id'])){
		if ($mage_settings['id'] !== $id) { 
			$mage_settings['id'] = $id;
			update_option('mage',$mage_settings);		
		}
	} else { 
		$mage_settings['id'] = $id;
		update_option('mage',$mage_settings);
	}
	if (get_option($mage_settings['id']) === false) mage_setdefaults();
	register_setting('mage',$mage_settings['id'],'mage_validate' );
}

function mage_setdefaults() {
	global $craft;
	$mage_settings = get_option('mage');
	$option_name = $mage_settings['id'];	
	if ( isset($mage_settings[$option_name.'_defaults']) ) {
		$defaults =  $mage_settings[$option_name.'_defaults'];
		if ( !in_array($option_name, $defaults) ) {
			array_push( $defaults, $option_name );
			$mage_settings[$option_name.'_defaults'] = $defaults;
			update_option('mage', $mage_settings);
		}
	} else {
		$newoptionname = array($option_name);
		$mage_settings[$option_name.'_defaults'] = $newoptionname;
		update_option('mage', $mage_settings);
	}	
	$options = $craft->options();	
	$values = $craft->default_values();	
	if ( isset($values) ) {
		add_option($option_name.'_defaults', $values );
	}
}
function mage_page() {
	global $craft;
?>
<div id="mage-wrap">
<?php settings_errors(); ?>
<div id="container" class="row">  
    <form id="mage-form" method="post" class="form-horizontal" action="options.php">
		<?php settings_fields('mage'); ?>
		<div id="magecast-content" class="magecast-content tab-content"><?php $craft->fields(); ?></div>
	<!-- Footer Navbar and Submit -->         
		<div class="navbar navbar-static-bottom">
            	<input type="submit" class="btn btn-brown" name="update" id="update" value="<?php esc_attr_e( 'Save Options', 'mage' ); ?>" />        	
 		</div>
    </form>
</div>
</div><?php
}
function mage_validate($input) {
	global $craft;
	if (!current_user_can('manage_options'))die('Insufficient Permissions');
	$clean = array();
	$options = $craft->options();	
	foreach ($options as $option ){
		if (!isset($option['id']))continue;
		if (!isset($option['type']))continue;
		$id = cog($option['id']);
		if (!isset($input[$id])) {
			if (in_array($option['type'], array('text','textarea','select','radio','color','upload')))$input[$id] = isset($option['std'])? $option['std']:'';		
			if ('checkbox' == $option['type'])$input[$id] = false;				
			if ('multicheck' == $option['type'])$input[$id] = array();					
		}
		if (has_filter('of_sanitize_' .$option['type'])){				
			$clean[$id] = apply_filters('of_sanitize_' . $option['type'], $input[$id], $option);	
		} 
	}
	add_settings_error('mage','save_options', __( 'Options saved.', 'paladin' ), 'updated modal fade in' );
	return $clean;
} 
function mage_get_option( $name, $default = false ) {
	$config = get_option( 'mage' );
	if (!isset( $config['id'])) return $default;
	$options = get_option( $config['id'] );
	if (isset( $options[$name])) return $options[$name];
	return $default;
}
if (!function_exists('magex')){
function magex($in, $pre='',$aft='', $default='') {
	if (!isset($in))return $default;
	$in = trim($in);
	if (!empty($in))return $pre.$in.$aft;
	return $default;
}
}
function cog($string='') {
	if (!empty($string)){
		$string = trim($string);
		$string = preg_replace('/[^A-Za-z0-9_-\s]/', '', $string);
		$string = strtolower(preg_replace('/\s+/', '-', $string));
	}
	return $string;
}
function mage_get_post_types($args=array(),$output ='names',$operator='and',$unset=array()) {
	$defaults =array('_builtin' => false);
	$args = empty($args) ? $defaults : $args;
	$builtin = apply_filters('mage_builtin_post_types',array());
	$unset = array_unique(array_merge($unset, $builtin));
    $post_types = get_post_types($args,$output,$operator);
    foreach ($post_types as $key => $val) {
        if (in_array($val,$unset)) {
            unset( $post_types[$key] );
        }
    }
    return $post_types;
}
class MageCraft {  
    public function __construct(){  	
		add_action('wp_ajax_mage_img_delete',array($this,'mage_img_delete'));
	}  
	public function mage_img_delete() {
        $attach_id = isset($_POST['id']) ? intval($_POST['id']) : 0;
		$test = wp_delete_attachment( $attach_id, true );
        if ($test !== false) { 
			die('jQuery("#update").trigger("click");'); 
		} else {
			die("alert('Error Deleting Image.');");
		}
	}
	public function options($page='') {	
	$options = array();		
	global $mage;
	if (empty($page)) { 
		$options = array();		
		$options = apply_filters('mage_options_dashboard',$options);		
	$options[] = array('name' => __('Ratings','gryphon'),'icon' => 'star','type' => 'heading');		
		$options[] = array('name' => __('Rate Types', 'paladin'),'parent' => 'ratings','type' => 'subheading');	
	$options[] = array(
		'name' => __('Attach to Post Types', 'novice'),
		'desc' => __('Choose the maximum rating that a user can rate content with.', 'novice'),
		'id' => 'post_type_ratings',		
		'type' => 'multicheck',
		'options'=>mage_post_type_options());
	$options[] = array(
		'name' => __('Display Average', 'novice'),
		'desc' => __('Display the average rating above your content.', 'novice'),
		'id' => 'display_average',		
		'type' => 'checkbox',
		'std' => '1');
	$options[] = array(
		'name' => __('Max. Rating', 'novice'),
		'desc' => __('Choose the maximum rating that a user can rate content with.', 'novice'),
		'id' => 'rate_count',
		'std' => '5',		
		'type' => 'select',
		'options'=>array('2'=>'2','3'=>'3','4'=>'4','5'=>'5','6'=>'6','7'=>'7','8'=>'8','9'=>'9','10'=>'10'));	
	$options[] = array(
		'name' => __('Rating Icons', 'paladin'),
		'desc' => __('The icon for each rating block before a user choose a rating.', 'paladin'),
		'id' => 'rating_icon',
		'std' => MAGEURL.'img/star-0.png',
		'type' => 'upload');
	$options[] = array(
		'name' => __('Rating Icon Hover', 'paladin'),
		'desc' => __('The icon that displays when a user hovers or chooses a rating.', 'paladin'),
		'id' => 'rating_icon_hover',
		'std' => MAGEURL.'img/star-1.png',
		'type' => 'upload');	
	}	
		return $options;	
	}
	public function default_values() {
		$output = array();
		$config = $this->options();
		foreach ( (array) $config as $option ) {
			if (!isset($option['id'])) {
				continue;
			}
			if (!isset($option['std']) || !isset($option['type'])) {
				continue;
			}
			if ( has_filter( 'of_sanitize_' . $option['type'] ) ) {
				$output[$option['id']] = apply_filters( 'of_sanitize_' . $option['type'], $option['std'], $option );
			}
		}
	return $output;
	}
	public function tabs($page='') {	
	$mage_settings = get_option('mage');
	$options = $this->options($page);
	$menu = ''; $i=0;
	foreach ($options as $value) {
	if ($i==0) {$first='class="page active"';} else {$first='class="page"';}
		if ($value['type'] == "heading") {
			$jquery_click_hook = preg_replace('/[^a-zA-Z0-9._\-]/', '', strtolower($value['name']) );
			$jquery_click_hook = "step-" . $jquery_click_hook;
			$icon = '';
			if (isset($value['icon'])) {$icon = (!empty($value['icon']))? '<i class="halflings-icon white '.$value['icon'].'"></i> ':'';}
			$menu .= '<li '.$first.'><a rel="tooltip" href="' . esc_attr( '#'.  $jquery_click_hook ) . '">'.$icon.' ' .esc_html( $value['name'] ) . '</a></li>'; $i++;
		}
	}
	return $menu;
}
	public function subtabs($subtabs='',$page='') {	
	$mage_settings = get_option('mage');	
	$options = $this->options($page);
	$menu =''; $i=0;
	foreach ($options as $value) {		
	if ($value['type'] == "subheading") {
		if ($value['parent'] == $subtabs) {
			if ($i==0) { 
				$first = 'class="subpage active"';
			} else {
				$first = 'class="subpage"';
			}
			$jquery_click_hook = cog($value['name']);
			$jquery_click_hook = "step-" . $jquery_click_hook;			
			$menu .= '<li '.$first.'><a href="' . esc_attr( '#'.  $jquery_click_hook ) . '" data-toggle="tab">' .esc_html( $value['name'] ) . '</a></li>'; $i++;
		}
	}
	}
	$menu = (!empty($menu)) ? '<ul class="nav nav-tabs mage-cast-nav">'.$menu.'</ul>' : '';
	return $menu;
}
	public function fields($page='') {
	global $allowedtags;
	$mage_settings = get_option('mage');
	if (isset($mage_settings['id']))$option_name = $mage_settings['id'];
	else $option_name = 'mage';
	$settings = get_option($option_name);
	$options = $this->options($page);
	$counter = 0;
	$subcounter = 0;
	$menu = $collapse = '';
	$submenus = array();	
	foreach($options as $value) {
		$counter++;
		$val = $select_value = $checked = $output = $active = $pre = $pre2 = $selected = $tigger = $slider = $prepend = $append = $attributes = '';	
		$div = false;
		$explain = isset( $value['desc'])? $value['desc']:'';
		if (!in_array($value['type'],array('heading','subheading','function','legend'))) {
			$id = cog($value['id']);
			$shortcode = isset($value['shortcode'])?' <code>'.$value['shortcode'].'</code>':'';
			$val = isset($value['std'])? $value['std']:'';
			$ph = isset($value['ph']) && !empty($value['ph'])? 'placeholder="'.$value['ph'].'"' : '';
			$class = ' form-group section-'. $value['type'].' ';
			$class .= isset($value['class']) && !empty($value['class'])? $value['class'] : '';	
			if(isset($settings[$value['id']])) {
				$val = $settings[$value['id']];				
				if (!is_array($val))$val = stripslashes($val);
			}			
			if (isset($value['pre']) && !empty($value['pre'])){
				$pre = '<div class="input-group"><span class="input-group-addon">'.$value['pre'].'</span>';
				$pre2 = '</div>';
			}
			$output .= '<div id="mage-' .$id.'" class="'.esc_attr( $class ).'">';
			if (!in_array($value['type'],array('textarea','checkbox','radio'))){
				if (!isset($value['inline'])){
					if (!isset($value['label-col'])) $value['label-col'] = 2;		
					if (isset($value['name']))$output .= '<label class="col-lg-'.$value['label-col'].' control-label" for="' .$value['id']. '">' .$value['name'].$shortcode.'</label>';
				} else {
					if (isset($value['name']))$output .= '<label for="' .$value['id']. '">' .$value['name'].$shortcode.'</label>';		}
			} 
		}			
		switch ($value['type']) {
		case 'text': 
			$text = (isset($value['pw']))? 'password' : 'text';		
			if (!isset($value['col'])) $value['col'] = 6;
			$output .= $prepend.'<div class="col-lg-'.$value['col'].'">';
			$output .= $pre.'<input id="' . esc_attr( $value['id'] ) . '" name="' . esc_attr($option_name.'['.$value['id'].']').'" type="'.$text.'" class="form-control" value="' . esc_attr( $val ) . '" '.$ph.' />'.$pre2.'</div>'.$append.$slider;					
		break;
		case 'textarea':
			$rows = isset($value['rows'])? $value['rows'] : '6';
			$val = stripslashes( $val );
			$output .= '<label for="' .$value['id']. '">' .$value['name'].$shortcode.'</label>';
			$output .= '<textarea id="' . esc_attr( $value['id'] ) . '" class="form-control mage-textarea" name="' . esc_attr( $option_name . '[' . $value['id'] . ']' ) . '" rows="' . $rows . '">' . esc_textarea( $val ) . '</textarea>';
		break;
		case 'select':			
			if (!isset($value['col'])) $value['col'] = 6;
			if ($value['col'] != 0) $output .= '<div class="col-lg-'.$value['col'].'">';
			$output .= '<select class="form-control mage-select" name="' . esc_attr( $option_name . '[' . $value['id'] . ']' ) . '" id="' . esc_attr( $value['id'] ) . '">';
			foreach ($value['options'] as $key => $option ) {				
				if (is_array($option)){
					$output .= '<optgroup label="' . esc_attr( $key ) . '">';
					foreach ($option as $opt => $op) {	
						if (!empty($val))$selected = ($val==$opt)? ' selected="selected"':''; 
						$output .= '<option'. $selected .' value="' . esc_attr($opt ) . '">' . esc_html( $op ) . '</option>';
					}
					$output .= '</optgroup>';
				} else {
					if (!empty($val))$selected = ($val==$key)? ' selected="selected"':''; 
					$output .= '<option'. $selected .' value="' . esc_attr( $key ) . '">' . esc_html( $option ) . '</option>';
				}
				
			}
			$output .= '</select>';
			if ($value['col'] != 0) $output .= '</div>';
		break;
		case 'radio':		
			$append = isset($value['name']) && isset($value['label-col'])? '</div>' : '';
			$output .= isset($value['name']) && isset($value['label-col'])? '<label class="col-lg-'.$value['label-col'].' control-label" for="' .$value['id']. '">' .$value['name'].$shortcode.'</label><div class="col-lg-10">':'<label for="' .$value['id']. '">' .$value['name'].$shortcode.'</label>';
			$btn = isset($value['btn'])? $value['btn'] : '';
			$output .= '<div class="btn-group" data-toggle="buttons">';
			foreach ($value['options'] as $key => $option) {	
				$checked=($val== $key)? 'checked="checked"' :'';		
				$active =( $val == $key ) ? ' active' :'';			
				$output .= '<button type="button" class="options btn'.$btn.$active.'" for="' . $value['id'] . '"><input class="mage-input mage-radio" type="radio" name="' . esc_attr($option_name .'['. $value['id'] .']') . '" id="' . esc_attr($option_name . '-' . cog($value['id']) .'-'. $key) . '" value="'. esc_attr( $key ) . '" '.$checked.' />' . $option  . '</button>';
			}
			$output .= '</div>'.$append;
		break;
		case "checkbox":
			$active = ($val)? 'active' : '';
			$output .= '<label class="col-lg-2 control-label" for="' . esc_attr( $value['id'] ) . '">' .$value['name'].$shortcode.'</label>
			<div class="col-lg-6"><label class="btn-activator '.$active.'" for="' . esc_attr( $value['id'] ) . '">
			<input id="' . esc_attr( $value['id'] ) . '" class="checkbox activator" type="checkbox" name="' . esc_attr( $option_name . '[' . $value['id'] . ']' ) . '" '. checked( $val, 1, false) .' /><span></span></label><span class="help-block">'.$explain.'</span></div>';
		break;
		case "multicheck":
			$output .= '<div class="col-lg-6"><div class="btn-group" data-toggle="buttons">';
			foreach ($value['options'] as $key => $option) {
				$id = $option_name . '-' . $value['id'] . '-'. $key;
				$name = $option_name . '[' . $value['id'] . '][]';
				$checked = is_array($val) && in_array($key,$val)? 'checked="checked"' : '';
				$active = is_array($val) && in_array($key,$val)? ' active' : '';
				$output .= '<label  class="checkbox inline btn btn-primary'.$active.'" for="' . esc_attr($name) . '"><input id="' . esc_attr( $id ) . '" class="checkbox" type="checkbox" name="' . esc_attr( $name ) . '" ' . $checked . ' value="'.$key.'" /> ' . esc_html( $option ) . '</label>';
			
			}
			$output .= '</div></div>';
		break;		
		case "color":
			$default_color = '';
			if(isset($value['std']))$default_color=($val != $value['std'])?' data-default-color="' .$value['std'] . '" ':'';
			$input = '<input name="' . esc_attr( $option_name . '[' . $value['id'] . ']' ) . '" id="' . esc_attr( $value['id'] ) . '" class="form-control mage-color"  type="text" value="' . esc_attr( $val ) . '"' . $default_color .' />';
			$output .= isset($value['span'])?'<div class="col-lg-10">'.$input.'</div>' : $input; 	
		break;
		case "upload":
			$var_data = is_array($val)? $val: array('src'=>$val);
			$var_data = wp_parse_args($var_data,array('src'=>'','width'=>'','height'=>'','id'=>''));
			$upload_id = $option_name.'['.esc_attr($value['id']).']';			
			$output .= '<div class="col-lg-6"><div class="input-group">
				<input id="' . esc_attr($value['id']) . '" class="form-control upload" type="text" name="'.$upload_id.'[src]" value="' . esc_attr($var_data['src']) . '" />
				<span class="input-group-btn">
					<button id="upload_'.esc_attr($value['id']).'" class="btn btn-success btn-background" type="button">' . __( 'Upload', 'paladin' ) . '</button>';
				if (mage_verify_image($var_data['id'],$var_data['src'])){
					$output .= '<a onclick="return mage_remove_image(\''.$var_data['id'].'\',\'' . esc_attr($value['id']) . '\');" name="'.$upload_id.'[delete]" id="delete_' . esc_attr($value['id']) . '" class="btn btn-danger trash" ><i class="halflings-icon white trash"></i></a>';
				}
      			$output .= '</span>			
			</div><input class="form-control upload_w hide" type="text" name="'.$upload_id.'[width]" value="' . esc_attr($var_data['width']) . '" />
				<input class="form-control upload_h hide" type="text" name="'.$upload_id.'[height]" value="' . esc_attr($var_data['height']) . '" />
				<input class="form-control upload_id hide" type="text" name="'.$upload_id.'[id]" value="' . esc_attr($var_data['id']) . '" />';	
			$output .= '</div>';	
			if(!empty($var_data['src']))$output .= '<div class="col-lg-1"><div class="mage-brand pull-right"><img rel="popover" data-title="Preview '. $value['name'] .'" src="'. esc_attr($var_data['src']) .'" style="max-height:40px;" alt="preview" /></div></div>';
			$output .= '<script>
			function mage_remove_image(id,field){
				mage_img_delete(id);
				jQuery("#"+field).attr("value", "");
				jQuery("#mage-"+field).find(".mage-brand").remove();
				return false;
			}
		</script>
       ';
		break;
		case "heading":
			$div = isset($value['div'])? $value['div'] : false;
			if ($counter != 1) {
				$output .= '</div></div>';
				$subcounter = 0;
			}
			if ($counter == 1)$output .= '<div class="mage-settings-page" id="step-' . cog($value['name']).'"><div class="content"><div class="scroller">';
			else $output .= '</div></div></div><div class="mage-settings-page" id="step-' . cog($value['name']) . '"><div class="content"><div class="scroller">';
			$output .= '<div class="page-header"><h2 class="heading">' . esc_html( $value['name'] ) . '</h2></div>' . "\n";
			$submenu = $this->subtabs(cog($value['name']),$page);
			$output .=(!empty($submenu))?$submenu : '';
		break;
		case "subheading":			
			$subcounter++;				
			if ($subcounter == 1)$output .= '<div class="mage-tab-content tab-content"><div class="tab-pane fade in active " id="step-' . cog($value['name']). '">';
			else $output .= '</div><div class="tab-pane fade" id="step-' . cog($value['name']) . '">';			
		break;
		case "legend":		
				$output .= '<div class="panel panel-default"><div class="panel-heading">';
				if (isset($value['options']) && isset($value['id'])){
					$output .= '<div class="btn-group" data-toggle="buttons" style="float:right;">';
					foreach ($value['options'] as $option => $name){
						$checked=($val== $option)? 'checked="checked"' :'';		
						$active =( $val == $option) ? ' active' :'';
						$output .= ' <label class="btn btn-default btn-xs btn-silver '.$active.'" for="'.esc_attr($option_name.'['.$value['id'].']').'"><input type="radio" name="'.esc_attr($option_name.'['.$value['id'].']').'"  value="'.$option.'" '.$checked.' /> '.$name.'</label>';
					}
					$output .= '</div>';
				}
				$output .= '<legend class="panel-title"><a class="accordion-toggle" data-toggle="collapse" href="#cast-'.cog($value['name']).'">'.$value['name'].'</a></legend>';	
		break;
		}		
		if (!in_array($value['type'], array('heading','subheading','function','html'))) {
			if ($value['type'] != "checkbox" && !empty($explain)) {
				$output .= '<div class="poppos"><a class="pop halflings question-sign" data-placement="left" rel="popover" data-content="' . wp_kses( $explain, $allowedtags) . '" data-title="'. wp_kses(  $value['name'], $allowedtags ).'"><i></i></a></div>';
			}
			if ($value['type'] == 'legend') {
				if ($value['type'] == 'legend'){
					$output .= '</div><div id="cast-'.cog($value['name']).'" class="panel-collapse collapse"><div class="panel-body">';
				} 
			} else {
				$output .= '</div><hr />';
			}		
		}
		echo $output;
	}
	echo '</div></div></div></div></div>';
}
}  
global $craft;
$craft = new MageCraft();