<?php

add_filter( 'of_sanitize_text', 'sanitize_text_field' );
add_filter( 'of_sanitize_textarea', 'of_sanitize_textarea' );
add_filter( 'of_sanitize_select', 'of_sanitize_enum', 10, 2);
add_filter( 'of_sanitize_radio', 'of_sanitize_enum', 10, 2);
add_filter( 'of_sanitize_legend', 'of_sanitize_enum', 10, 2);
add_filter( 'of_sanitize_images', 'of_sanitize_enum', 10, 2);
add_filter( 'of_sanitize_checkbox', 'of_sanitize_checkbox' );
add_filter( 'of_sanitize_multicheck', 'of_sanitize_multicheck', 10, 2 );
add_filter( 'of_sanitize_color', 'of_sanitize_hex' );
add_filter( 'of_sanitize_upload', 'of_sanitize_upload' );
add_filter( 'of_sanitize_editor', 'of_sanitize_editor' );
add_filter( 'of_sanitize_info', 'of_sanitize_allowedposttags' );

/* Checkbox */
function of_sanitize_textarea($input) {
	global $allowedposttags;
	$output = wp_kses( $input, $allowedposttags);
	return $output;
}
function of_sanitize_checkbox( $input ) {
	return $input? '1' : false;
}
/* Multicheck */
function of_sanitize_multicheck( $input, $option ) {
	$output = array();
	if ( is_array( $input ) && !empty($input) ) {
		return $input;
		foreach( $input as $key) {
			if ( array_key_exists( $key, $option['options'] )) {
				$output[] = $key;
			}
		}
	}
	return $output;
}
/* Uploader */
function of_sanitize_upload( $input ) {	
	if (is_array($input)){
		$output = array('src'=>'', 'width'=>'','height'=>'','id'=>'');
		$filetype = wp_check_filetype($input['src']);
		if ( $filetype["ext"] ) $output = array('src'=>$input['src'], 'width'=>$input['width'],'height'=>$input['height'],'id'=>$input['id']);
	} else {
		$output = '';
		$filetype = wp_check_filetype($input);
		if ( $filetype["ext"] ) $output = $input;
	}
	return $output;
}

/* Editor */
function of_sanitize_editor($input) {
	if ( current_user_can( 'unfiltered_html' ) ) {
		$output = $input;
	}
	else {
		global $allowedtags;
		$output = wpautop(wp_kses( $input, $allowedtags));
	}
	return $output;
}
/* Allowed Tags */
function of_sanitize_allowedtags($input) {
	global $allowedtags;
	$output = wpautop(wp_kses( $input, $allowedtags));
	return $output;
}

/* Allowed Post Tags */
function of_sanitize_allowedposttags($input) {
	global $allowedposttags;
	$output = wpautop(wp_kses( $input, $allowedposttags));
	return $output;
}
/* Check that the key value sent is valid */
function of_sanitize_enum( $input, $option ) {
	$output = '';
	foreach ($option['options'] as $keys => $vals){
		if (is_array($vals)){
			if ( array_key_exists( $input, $vals) ) {
				$output = $input;
			}
		}
	}
	if ( array_key_exists( $input, $option['options'] ) ) {
		$output = $input;
	}
	return $output;
}